package com.billdawson.facebooknative;

import java.io.IOException;
import java.net.MalformedURLException;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

import com.facebook.android.DialogError;
import com.facebook.android.Facebook;
import com.facebook.android.FacebookError;

public class FacebookNativeActivity extends Activity
{
	private final static String TAG = "FacebookNative";
	private Facebook facebook = null;
	private static final String[] permissions = {"publish_stream", "read_stream"};
	
	private TextView statusLabel = null;
	
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		facebook = new Facebook("134793934930");
		setContentView(R.layout.main);
		statusLabel = (TextView) findViewById(R.id.lbl);
		Button loginButton = (Button) findViewById(R.id.login);
		Button dodialogButton = (Button) findViewById(R.id.dodialog);
		Button logoutButton = (Button) findViewById(R.id.logout);
		loginButton.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v)
			{
				facebook.authorize(FacebookNativeActivity.this, permissions, Facebook.FORCE_DIALOG_AUTH,
					new Facebook.DialogListener() {
						
						@Override
						public void onFacebookError(FacebookError e)
						{
							setStatus(e.getMessage());
						}
						
						@Override
						public void onError(DialogError e)
						{
							setStatus(e.getMessage());
						}
						
						@Override
						public void onComplete(Bundle values)
						{
							setStatus("Login successful");
						}
						
						@Override
						public void onCancel()
						{
							setStatus("Login canceled");
						}
					});
			}
		});
		logoutButton.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v)
			{
				try {
					facebook.logout(FacebookNativeActivity.this);
				} catch (MalformedURLException e) {
					setStatus(e.getMessage());
					Log.e(TAG, e.getMessage());
				} catch (IOException e) {
					Log.e(TAG, e.getMessage());
				}
			}
		});
		dodialogButton.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v)
			{
				Bundle bundle = new Bundle();
				bundle.putString("link", "http://www.appcelerator.com");
				bundle.putString("name", "Appcelerator Titanium (iteration x)");
				bundle.putString("message", "Awesome SDKs for building desktop and mobile apps");
				bundle.putString("caption", "Appcelerator Titanium (iteration x)");
				bundle.putString("picture", "http://developer.appcelerator.com/assets/img/DEV_titmobile_image.png");
				bundle.putString("description", "You've got the ideas, now you've got the power. Titanium translates your hard won web skills...");
				facebook.dialog(FacebookNativeActivity.this, "feed", bundle,
					new Facebook.DialogListener() {
						@Override
						public void onFacebookError(FacebookError e)
						{
							setStatus(e.getMessage());
							Log.e(TAG, "FacebookError: " + e.getMessage());
						}
						
						@Override
						public void onError(DialogError e)
						{
							setStatus(e.getMessage());
							Log.e(TAG, "DialogError: " + e.getMessage());
						}
						
						@Override
						public void onComplete(Bundle values)
						{
							setStatus("Done");
						}
						
						@Override
						public void onCancel()
						{
							setStatus("Canceled");
						}
					});
			}
		});
	}
	
	private void setStatus(String msg)
	{
		statusLabel.setText(msg);
	}
}
